<?php
namespace Teknisa\PLA\Modules\Mymenu\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class Mym00103ProgramacaoPesquisaController {
    protected $crudService;
    
	public function __construct($crudService){
	    $this->crudService = $crudService;
	}
    public function saveProgramacaoPesquisa(DTO\Request $request, DTO\Response $response){
            try{
                  $row = (array) $request->getRow();
                    $conditions = array(
                        array(
                            "columnName" => "HRINICIO",
                            "operator" => "=",
                            "value" => $row['HRINICIO']
                        ),
                        array(
                            "columnName" => "HRFIM",
                            "operator" => "=",
                            "value" => $row['HRFIM']
                        ),
                        array(
                            "columnName" => "DTINICIO",
                            "operator" => "=",
                            "value" => $row['DTINICIO']
                        ),
                        array(
                            "columnName" => "DTFIM",
                            "operator" => "=",
                            "value" => $row['DTFIM']
                        ),
                        array(
                            "columnName" => "NRLOCALPESQ",
                            "operator" => "=",
                            "value" => $row['NRLOCALPESQ']
                        ),
                         array(
                            "columnName" => "CDFILIAL",
                            "operator" => "=",
                            "value" => $row['CDFILIAL']
                        ),
                        array(
                            "columnName" => "NRORG",
                            "operator" => "=",
                            "value" => $this->crudService->getEnvironment()->getNrOrg()
                        )
            );
            $resultProgramacao = $this->crudService->getFilteredDataSet('programacao_valida_save', $conditions)->getRows();
                if(count($resultProgramacao) == 0 || $row['__is_new'] == false){
                    $dataSourceName = 'programacaopesq';
                    $this->crudService->save($dataSourceName, $this->crudService->getRowsToSave($request, $dataSourceName));
                }else{
                     throw new \Exception(13);
                }
            }  catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }   
    }
}
